#if !defined(EXTERNC)
    #if defined(__cplusplus)
        #define EXTERNC extern "C"
    #else
        #define EXTERNC
    #endif
#endif


#define stdcall __stdcall
#define dllexport __declspec(dllexport)

// This class is exported from the NXL_DLL.dll
EXTERNC class dllexport CNXL_DLL {
public:
	CNXL_DLL(void);
	BOOL stdcall Get_LibEnabled() const {return m_bLibEnabled;};
	
	double stdcall NXL_VersionNo(void);
	short stdcall BuildNet(short* numinputs, short* numhidden, short* numoutputs, short* jumplink);
	short stdcall BuildNetL(short* numinputs, short* numhidden, short* numoutputs);
	void stdcall ReleaseNet(void);
	void stdcall Set_MaxNumNodes(short mnn);
	void stdcall Set_TrainingSize(long np);
	void stdcall Set_TestSize(long np);
	void stdcall Set_NumInputs(short ni);
	void stdcall Set_NumHiddens(short nh);
	void stdcall Set_NumOutputs(short no);
	short stdcall Get_NumOutputs(void) const;
	short stdcall Get_NumInputs(void) const;
	short stdcall Get_NumHiddens(void) const;
	short stdcall Get_MaxNumNodes(void) const;
	short stdcall Get_MemAllocated(void) const;
	void stdcall Set_Decay(double d);
	void stdcall Set_Seed(short s);
	void stdcall Set_PruningCutOff(double pco);
	void stdcall Set_WeightRange(double wr);
	void stdcall Set_SigOffset(double o);
	void stdcall Set_Epsilon(double e);
	void stdcall Set_MaxFactor(double mf);
	void stdcall Set_HyperErr(short e);
	void stdcall Set_Pruning(short p);
	short stdcall Get_Pruning(void) const;
	void stdcall Set_JumpLinks(short p);
	void stdcall Set_Tolerance(double dT);
	double stdcall Get_Tolerance(void) const;
	short stdcall Get_JumpLinks(void) const;
	double stdcall Get_WeightRange(void) const;
	double stdcall Get_Decay(void) const;
	short stdcall Get_Seed(void) const;
	double stdcall Get_PruningCutOff(void) const;
	double stdcall Get_MaxFactor(void) const;
	short stdcall Get_HyperErr(void) const;
	double stdcall Get_Epsilon(void) const;
	double stdcall Get_SigOffset(void) const;
	short stdcall Get_SplitEpsilon(void) const;
	void stdcall Set_SplitEpsilon(short nSE);
	double stdcall Get_Weight(short i, short j) const;
	void stdcall Set_Weight(short i, short j, double val);
	double stdcall Load_TrainPatternInput(short *inputno, long *patno, double *i);
	double stdcall Load_TestPatternInput(short *inputno, long *patno, double *i);
	double stdcall Load_TrainPatternOutput(short *outputno, long *patno, double *i);
	double stdcall Load_TestPatternOutput(short *outputno, long *patno, double *i);
	double stdcall Save_TrainPatternInput(short *inputno, long *patno);
	double stdcall Save_TestPatternInput(short *inputno, long *patno);
	double stdcall Save_TrainPatternOutput(short *outputno, long *patno);
	double stdcall Save_TestPatternOutput(short *outputno, long *patno);
	double stdcall TotalNetError(void) const;
	double stdcall AvgTrainNetError(void) const;
	double stdcall AvgTestNetError(void) const;
	double stdcall Train_1Epoch (void);
	double stdcall Train_Epochs ( short times );
	double stdcall RunTrainingPatternThroughNet (long patno, short outno);
	void stdcall ResetTestError (void);
	double stdcall GetTestError (void) const;
	double stdcall RunTestPatternThroughNet (long patno, short outno);
	double stdcall TestNet(short outno);
	double stdcall Contribution(short inp, short out);

	int stdcall EnableLibrary( char *str );

	long stdcall GetNXLcount(void) const;

private:

	static long NXLcount;
	BOOL m_bLibEnabled;
	long m_nEpoch;               // Current m_nEpoch number

	int m_nFixedSeed;
	double m_dWeightRange;
	double m_dSigmoidPrimeOffset;
	BOOL m_bHyperErr;
	double m_dTolerance;
	BOOL m_bAllowPruning;
	BOOL m_bUseJumpLinks;
	BOOL m_bSplitEpsilon;
	BOOL m_bOutputNodesId;
	double m_dEpsilon;
	double m_dMaxFactor;
	double m_dShrink_Factor;
	double m_dDecay;
	double m_dPruningCutOff;
	double m_dTotalTrainError;
	double m_dTotalTestError;
	short m_nNumUnits;
	short m_nNumInputs;
	short m_nFirstHidden;
	short m_nNumHidden;
	short m_nFirstOutput;
	short m_nNumOutputs;
	long m_nNTrainingPatterns;
	long m_nNTestPatterns;
	short m_nMaxNumNeurons;
	double* m_dOutputs;
	double* m_dErrorSums;
	double* m_dErrors;
	unsigned short*m_nNconnections;
	int** m_nConnections;
	double** m_dWeights;
	double** m_dDeltaWeights;
	double** m_dSlopes;
	double** m_dPrevSlopes;
	double** m_dTrainingInputs;
	double** m_dTrainingOutputs;
	double** m_dTestInputs;
	double** m_dTestOutputs;
	short InitMemory(void);
	void ReleaseMemory(void);
	short Build_Data_Structures(short nInputs, short nHidden, short nOutputs);
	double Random_Weight(double range);
	void Connect_Layers(short start1, short end1, short start2, short end2);
	void Clear_Slopes(void);
	void Forward_Pass(long patno);
	void Backward_Pass(long patno);
	void Update_Weights(void);
	int m_nNNidentifier;

};


